import os
import subprocess
import psutil
import winreg

def set_process_priority(process_name, priority=psutil.HIGH_PRIORITY_CLASS):
    for proc in psutil.process_iter():
        try:
            if process_name.lower() in proc.name().lower():
                proc.nice(priority)
                print(f"Priorité du processus {proc.name()} réglée sur haute.")
        except (psutil.NoSuchProcess, psutil.AccessDenied, psutil.ZombieProcess):
            pass

def suggest_graphics_settings():
    print("Veuillez régler manuellement les paramètres graphiques de Valorant pour maximiser les FPS :")
    print("1. Baissez la résolution à 1280x720 ou moins si nécessaire.")
    print("2. Réglez la qualité graphique générale sur 'Low'.")
    print("3. Désactivez les ombres et les effets visuels non essentiels.")
    print("4. Activez le mode 'Limiter FPS' pour éviter les fluctuations.")

def free_memory():
    try:
        subprocess.run("EmptyStandbyList.exe workingsets", shell=True)
        subprocess.run("EmptyStandbyList.exe standbylist", shell=True)
        print("Mémoire libérée avec succès.")
    except Exception as e:
        print(f"Erreur lors du nettoyage de la mémoire : {e}")

def disable_unnecessary_services():
    services_to_disable = [
        'SysMain',
        'DiagTrack',
        'WSearch'
    ]
    for service in services_to_disable:
        try:
            subprocess.run(f"sc stop {service}", shell=True)
            subprocess.run(f"sc config {service} start= disabled", shell=True)
            print(f"Service {service} désactivé.")
        except Exception as e:
            print(f"Erreur lors de la désactivation du service {service} : {e}")

def optimize_virtual_memory():
    try:
        subprocess.run("wmic computersystem where name=\"%computername%\" set AutomaticManagedPagefile=False", shell=True)
        subprocess.run("wmic pagefileset where name=\"C:\\\\pagefile.sys\" set InitialSize=4096,MaximumSize=8192", shell=True)
        print("Mémoire virtuelle optimisée.")
    except Exception as e:
        print(f"Erreur lors de l'optimisation de la mémoire virtuelle : {e}")

def set_valorant_priority():
    set_process_priority("VALORANT.exe", psutil.HIGH_PRIORITY_CLASS)
    set_process_priority("RiotClientServices.exe", psutil.HIGH_PRIORITY_CLASS)

def disable_game_dvr():
    try:
        key = winreg.OpenKey(winreg.HKEY_CURRENT_USER, r"SOFTWARE\Microsoft\Windows\CurrentVersion\GameDVR", 0, winreg.KEY_ALL_ACCESS)
        winreg.SetValueEx(key, "AppCaptureEnabled", 0, winreg.REG_DWORD, 0)
        winreg.SetValueEx(key, "GameDVR_Enabled", 0, winreg.REG_DWORD, 0)
        winreg.CloseKey(key)
        print("Game DVR désactivé.")
    except Exception as e:
        print(f"Erreur lors de la désactivation de Game DVR : {e}")

def optimize_valorant():
    print("Optimisation de Valorant pour gagner des FPS...")
    
    suggest_graphics_settings()
    
    optimize_virtual_memory()
    
    disable_unnecessary_services()
    
    free_memory()
    
    set_valorant_priority()
    
    disable_game_dvr()

    print("Optimisation complète terminée pour Valorant.")

if __name__ == "__main__":
    optimize_valorant()
